<template>
  <div class="home col-5 mx-auto">
    <h1 class="text-center">Register</h1>
    <div class="card">
      <div class="card-body">
        <div class="form-group">
          <label for="name">Name:</label>
          <input
            type="text"
            v-model="form.name"
            class="form-control"
            id="name"
          />
          <span class="text-danger" v-if="errors.name">
            {{ errors.name[0] }}
          </span>
          <span id="nameHelp" class="text-danger" v-if="!check_name.name_valid">Name must
            <span v-if="!check_name.name_required">be not empty.</span>
            <span v-if="!check_name.name_min_length">has atleast 3 characters.</span>
            <span v-if="!check_name.name_max_length">be shorter than 256 characters.</span>
            <span v-if="!check_name.name_string">be a string.</span>
            <span v-if="!check_name.name_special">hasn't a special characters.</span>
          </span>
        </div>
        <div class="form-group">
          <label for="email">Email address:</label>
          <input
            type="email"
            v-model="form.email"
            class="form-control"
            id="email"
          />
          <span class="text-danger" v-if="errors.email">
            {{ errors.email[0] }}
          </span>
            <!--email_required: true,
            email_string: true,
            email_email: true,
            email_max_length: true,
            email_special: true,
            email_valid: true-->
        <span id="emailHelp" class="text-danger" v-if="!check_email.email_valid">Email must
            <span v-if="!check_email.email_required">be not empty.</span>
            <span v-if="!check_email.email_string">be a string.</span>
            <span v-if="!check_email.email_email">look like email (has a "." and "@").</span>
            <span v-if="!check_email.email_max_length">be shorter than 256 characters.</span>
            <span v-if="!check_email.email_special">hasn't a special characters (except "." and "@").</span>
        </span>
        </div>
        <div class="form-group">
          <label for="password">Password:</label>
          <input
            type="password"
            v-model="form.password"
            class="form-control"
            id="password"
          />
          <span class="text-danger" v-if="errors.password">
            {{ errors.password[0] }}
          </span>
          <span id="passwordHelp" class="text-danger" v-if="!check_password.password_valid && check_password.password_confirmation">Password must
            <span v-if="!check_password.password_required">be not empty.</span>
            <span v-if="!check_password.password_minimum_length">has atleast 6 characters.</span>
            <span v-if="!check_password.password_number">has one digit.</span>
            <span v-if="!check_password.password_lowercase">has one lowercase letter.</span>
            <span v-if="!check_password.password_uppercase">has one uppercase letter.</span>
            <span v-if="!check_password.password_special">hasn't special characters.</span>
          </span>
        </div>
        <div class="form-group">
          <label for="password_confirmation">Confirm Password:</label>
          <input
            type="password"
            v-model="form.password_confirmation"
            class="form-control"
            id="password_confirmation"
          />
          <span class="text-danger" v-if="errors.password_confirmation">
            {{ errors.password_confirmation[0] }}
          </span>
          <span class="text-danger" v-if="!check_password.password_confirmation">
            Password wasn't confirmed.
          </span>
        </div>
        <button
          type="submit"
          @click.prevent="register"
          class="btn btn-primary btn-block"
        >
          Register
        </button>
      </div>
    </div>
  </div>
</template>

<script>
import User from "../src/apis/User";
import eventHub from '../eventHub';
import shared from '../layouts/Shared';

export default {
  data() {
    return {
      form: shared.data.form,
      check_name: shared.data.check_name,
      check_email: shared.data.check_email,
      check_password: shared.data.check_password,
      errors: []
    };
  },
  methods: {
    checkName: shared.methods.checkName,
    checkEmail: shared.methods.checkEmail,
    checkPassword: shared.methods.checkPassword,
    register() {
        if (
            this.checkName() &&
            this.checkEmail() &&
            this.checkPassword()
        ) {
            User.register(this.form)
            .then(response => {
                this.login();
            })
            .catch(error => {
                if (error.response.status === 422) {
                    this.errors = error.response.data.errors;
                }
            });
        }
    },
    login() {
      User.login(this.form)
        .then((resp) => {
          localStorage.setItem("token", resp.data.data.token);
          eventHub.$emit('auth-navbar');
          this.$router.push({ name: "home" });
        })
        .catch(error => {
          if (error.resp.status === 422) {
            this.errors = error.resp.data.errors;
          }
        });
    }

  }
};

</script>


